classdef DSP_Record < handle
properties
  record
  fieldNames
  debug
end % properties
   
methods
function obj = DSP_Record(dbRecordArg)     % CONSTRUCTOR
  obj.record = dbRecordArg;
  obj.fieldNames = cell(1, obj.record.Fields.Count);
  obj.debug = 1;        % USED TO GET VERBOSE SQL ERROR MESSAGES
  for i = 0 : (obj.record.Fields.Count-1)
    obj.fieldNames {i+1} = obj.record.Fields.Item(i).Name;
  end
end

%%%%%%
     
function returnValue = DSP_GetFieldValue(obj, fieldName)
  try   % USEFUL OPTION TO HAVE WORKING WITH A NULL DB RECORD
    obj.record.MoveFirst( );
  catch
    if obj.debug == 1     
      fprintf('Probably a NULL  object -- returning NaN\n');
    end
  	returnValue = NaN;     % CONSIDER REFACTORING TO RETURN NaN IN LONG TERM
    return;
  end
            
  fieldValue = obj.record.Fields.Item(fieldName).Value;
  fieldType = obj.record.Fields.Item(fieldName).Type;
  
  if strcmp('adLongVarBinary', fieldType)
    buf = typecast(fieldValue, 'int8');
    castFieldValue = SerializeData.GetObjectFromBytes(buf);      
   if strcmp(class(castFieldValue), 'java.lang.String[]') == 1
                castFieldValue = cell(castFieldValue);
    end
    [cols,rows] = size(castFieldValue);
    if strcmp(class(castFieldValue),'char') == 0 && (rows <= 1 || cols <= 1)
      castFieldValue = castFieldValue';
    end
    returnValue = castFieldValue;
%      float2 = BLOBtoDouble(buf);
%      fprintf('ToBlob: %d %d\n', length(returnValue), length(float2));
     
  else    % CAST EVERYTHING ELSE AS A FLOAT
     returnValue = double(fieldValue); 
  end
end

end % methods
end % class
